﻿/* Still Exporter 1.1.001
  Copyright (c) 2014 - 2019 mamoworld
  All rights reserved.
 
  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED,
  INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR
  PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE
  LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT
  OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
  OTHER DEALINGS IN THE SOFTWARE.l
*/

$._extStillExporter = ((function() {
/*
    json2.js
    2014-02-04

    Public Domain.

    NO WARRANTY EXPRESSED OR IMPLIED. USE AT YOUR OWN RISK.

    See http://www.JSON.org/js.html


    This code should be minified before deployment.
    See http://javascript.crockford.com/jsmin.html

    USE YOUR OWN COPY. IT IS EXTREMELY UNWISE TO LOAD CODE FROM SERVERS YOU DO
    NOT CONTROL.


    This file creates a global JSON object containing two methods: stringify
    and parse.

        JSON.stringify(value, replacer, space)
            value       any JavaScript value, usually an object or array.

            replacer    an optional parameter that determines how object
                        values are stringified for objects. It can be a
                        function or an array of strings.

            space       an optional parameter that specifies the indentation
                        of nested structures. If it is omitted, the text will
                        be packed without extra whitespace. If it is a number,
                        it will specify the number of spaces to indent at each
                        level. If it is a string (such as '\t' or '&nbsp;'),
                        it contains the characters used to indent at each level.

            This method produces a JSON text from a JavaScript value.

            When an object value is found, if the object contains a toJSON
            method, its toJSON method will be called and the result will be
            stringified. A toJSON method does not serialize: it returns the
            value represented by the name/value pair that should be serialized,
            or undefined if nothing should be serialized. The toJSON method
            will be passed the key associated with the value, and this will be
            bound to the value

            For example, this would serialize Dates as ISO strings.

                Date.prototype.toJSON = function (key) {
                    function f(n) {
                        // Format integers to have at least two digits.
                        return n < 10 ? '0' + n : n;
                    }

                    return this.getUTCFullYear()   + '-' +
                         f(this.getUTCMonth() + 1) + '-' +
                         f(this.getUTCDate())      + 'T' +
                         f(this.getUTCHours())     + ':' +
                         f(this.getUTCMinutes())   + ':' +
                         f(this.getUTCSeconds())   + 'Z';
                };

            You can provide an optional replacer method. It will be passed the
            key and value of each member, with this bound to the containing
            object. The value that is returned from your method will be
            serialized. If your method returns undefined, then the member will
            be excluded from the serialization.

            If the replacer parameter is an array of strings, then it will be
            used to select the members to be serialized. It filters the results
            such that only members with keys listed in the replacer array are
            stringified.

            Values that do not have JSON representations, such as undefined or
            functions, will not be serialized. Such values in objects will be
            dropped; in arrays they will be replaced with null. You can use
            a replacer function to replace those with JSON values.
            JSON.stringify(undefined) returns undefined.

            The optional space parameter produces a stringification of the
            value that is filled with line breaks and indentation to make it
            easier to read.

            If the space parameter is a non-empty string, then that string will
            be used for indentation. If the space parameter is a number, then
            the indentation will be that many spaces.

            Example:

            text = JSON.stringify(['e', {pluribus: 'unum'}]);
            // text is '["e",{"pluribus":"unum"}]'


            text = JSON.stringify(['e', {pluribus: 'unum'}], null, '\t');
            // text is '[\n\t"e",\n\t{\n\t\t"pluribus": "unum"\n\t}\n]'

            text = JSON.stringify([new Date()], function (key, value) {
                return this[key] instanceof Date ?
                    'Date(' + this[key] + ')' : value;
            });
            // text is '["Date(---current time---)"]'


        JSON.parse(text, reviver)
            This method parses a JSON text to produce an object or array.
            It can throw a SyntaxError exception.

            The optional reviver parameter is a function that can filter and
            transform the results. It receives each of the keys and values,
            and its return value is used instead of the original value.
            If it returns what it received, then the structure is not modified.
            If it returns undefined then the member is deleted.

            Example:

            // Parse the text. Values that look like ISO date strings will
            // be converted to Date objects.

            myData = JSON.parse(text, function (key, value) {
                var a;
                if (typeof value === 'string') {
                    a =
/^(\d{4})-(\d{2})-(\d{2})T(\d{2}):(\d{2}):(\d{2}(?:\.\d*)?)Z$/.exec(value);
                    if (a) {
                        return new Date(Date.UTC(+a[1], +a[2] - 1, +a[3], +a[4],
                            +a[5], +a[6]));
                    }
                }
                return value;
            });

            myData = JSON.parse('["Date(09/09/2001)"]', function (key, value) {
                var d;
                if (typeof value === 'string' &&
                        value.slice(0, 5) === 'Date(' &&
                        value.slice(-1) === ')') {
                    d = new Date(value.slice(5, -1));
                    if (d) {
                        return d;
                    }
                }
                return value;
            });


    This is a reference implementation. You are free to copy, modify, or
    redistribute.
*/

/*jslint evil: true, regexp: true */

/*members "", "\b", "\t", "\n", "\f", "\r", "\"", JSON, "\\", apply,
    call, charCodeAt, getUTCDate, getUTCFullYear, getUTCHours,
    getUTCMinutes, getUTCMonth, getUTCSeconds, hasOwnProperty, join,
    lastIndex, length, parse, prototype, push, replace, slice, stringify,
    test, toJSON, toString, valueOf
*/


// Create a JSON object only if one does not already exist. We create the
// methods in a closure to avoid creating global variables.

if (typeof JSON !== 'object') {
    JSON = {};
}

(function () {
    'use strict';

    function f(n) {
        // Format integers to have at least two digits.
        return n < 10 ? '0' + n : n;
    }

    if (typeof Date.prototype.toJSON !== 'function') {

        Date.prototype.toJSON = function () {

            return isFinite(this.valueOf())
                ? this.getUTCFullYear()     + '-' +
                    f(this.getUTCMonth() + 1) + '-' +
                    f(this.getUTCDate())      + 'T' +
                    f(this.getUTCHours())     + ':' +
                    f(this.getUTCMinutes())   + ':' +
                    f(this.getUTCSeconds())   + 'Z'
                : null;
        };

        String.prototype.toJSON      =
            Number.prototype.toJSON  =
            Boolean.prototype.toJSON = function () {
                return this.valueOf();
            };
    }

    var cx,
        escapable,
        gap,
        indent,
        meta,
        rep;


    function quote(string) {

// If the string contains no control characters, no quote characters, and no
// backslash characters, then we can safely slap some quotes around it.
// Otherwise we must also replace the offending characters with safe escape
// sequences.

        escapable.lastIndex = 0;
        return escapable.test(string) ? '"' + string.replace(escapable, function (a) {
            var c = meta[a];
            return typeof c === 'string'
                ? c
                : '\\u' + ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
        }) + '"' : '"' + string + '"';
    }


    function str(key, holder) {

// Produce a string from holder[key].

        var i,          // The loop counter.
            k,          // The member key.
            v,          // The member value.
            length,
            mind = gap,
            partial,
            value = holder[key];

// If the value has a toJSON method, call it to obtain a replacement value.

        if (value && typeof value === 'object' &&
                typeof value.toJSON === 'function') {
            value = value.toJSON(key);
        }

// If we were called with a replacer function, then call the replacer to
// obtain a replacement value.

        if (typeof rep === 'function') {
            value = rep.call(holder, key, value);
        }

// What happens next depends on the value's type.

        switch (typeof value) {
        case 'string':
            return quote(value);

        case 'number':

// JSON numbers must be finite. Encode non-finite numbers as null.

            return isFinite(value) ? String(value) : 'null';

        case 'boolean':
        case 'null':

// If the value is a boolean or null, convert it to a string. Note:
// typeof null does not produce 'null'. The case is included here in
// the remote chance that this gets fixed someday.

            return String(value);

// If the type is 'object', we might be dealing with an object or an array or
// null.

        case 'object':

// Due to a specification blunder in ECMAScript, typeof null is 'object',
// so watch out for that case.

            if (!value) {
                return 'null';
            }

// Make an array to hold the partial results of stringifying this object value.

            gap += indent;
            partial = [];

// Is the value an array?

            if (Object.prototype.toString.apply(value) === '[object Array]') {

// The value is an array. Stringify every element. Use null as a placeholder
// for non-JSON values.

                length = value.length;
                for (i = 0; i < length; i += 1) {
                    partial[i] = str(i, value) || 'null';
                }

// Join all of the elements together, separated with commas, and wrap them in
// brackets.

                v = partial.length === 0
                    ? '[]'
                    : gap
                    ? '[\n' + gap + partial.join(',\n' + gap) + '\n' + mind + ']'
                    : '[' + partial.join(',') + ']';
                gap = mind;
                return v;
            }

// If the replacer is an array, use it to select the members to be stringified.

            if (rep && typeof rep === 'object') {
                length = rep.length;
                for (i = 0; i < length; i += 1) {
                    if (typeof rep[i] === 'string') {
                        k = rep[i];
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            } else {

// Otherwise, iterate through all of the keys in the object.

                for (k in value) {
                    if (Object.prototype.hasOwnProperty.call(value, k)) {
                        v = str(k, value);
                        if (v) {
                            partial.push(quote(k) + (gap ? ': ' : ':') + v);
                        }
                    }
                }
            }

// Join all of the member texts together, separated with commas,
// and wrap them in braces.

            v = partial.length === 0
                ? '{}'
                : gap
                ? '{\n' + gap + partial.join(',\n' + gap) + '\n' + mind + '}'
                : '{' + partial.join(',') + '}';
            gap = mind;
            return v;
        }
    }

// If the JSON object does not yet have a stringify method, give it one.

    if (typeof JSON.stringify !== 'function') {
        escapable = /[\\\"\x00-\x1f\x7f-\x9f\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;
        meta = {    // table of character substitutions
            '\b': '\\b',
            '\t': '\\t',
            '\n': '\\n',
            '\f': '\\f',
            '\r': '\\r',
            '"' : '\\"',
            '\\': '\\\\'
        };
        JSON.stringify = function (value, replacer, space) {

// The stringify method takes a value and an optional replacer, and an optional
// space parameter, and returns a JSON text. The replacer can be a function
// that can replace values, or an array of strings that will select the keys.
// A default replacer method can be provided. Use of the space parameter can
// produce text that is more easily readable.

            var i;
            gap = '';
            indent = '';

// If the space parameter is a number, make an indent string containing that
// many spaces.

            if (typeof space === 'number') {
                for (i = 0; i < space; i += 1) {
                    indent += ' ';
                }

// If the space parameter is a string, it will be used as the indent string.

            } else if (typeof space === 'string') {
                indent = space;
            }

// If there is a replacer, it must be a function or an array.
// Otherwise, throw an error.

            rep = replacer;
            if (replacer && typeof replacer !== 'function' &&
                    (typeof replacer !== 'object' ||
                    typeof replacer.length !== 'number')) {
                throw new Error('JSON.stringify');
            }

// Make a fake root object containing our value under the key of ''.
// Return the result of stringifying the value.

            return str('', {'': value});
        };
    }


// If the JSON object does not yet have a parse method, give it one.

    if (typeof JSON.parse !== 'function') {
        cx = /[\u0000\u00ad\u0600-\u0604\u070f\u17b4\u17b5\u200c-\u200f\u2028-\u202f\u2060-\u206f\ufeff\ufff0-\uffff]/g;
        JSON.parse = function (text, reviver) {

// The parse method takes a text and an optional reviver function, and returns
// a JavaScript value if the text is a valid JSON text.

            var j;

            function walk(holder, key) {

// The walk method is used to recursively walk the resulting structure so
// that modifications can be made.

                var k, v, value = holder[key];
                if (value && typeof value === 'object') {
                    for (k in value) {
                        if (Object.prototype.hasOwnProperty.call(value, k)) {
                            v = walk(value, k);
                            if (v !== undefined) {
                                value[k] = v;
                            } else {
                                delete value[k];
                            }
                        }
                    }
                }
                return reviver.call(holder, key, value);
            }


// Parsing happens in four stages. In the first stage, we replace certain
// Unicode characters with escape sequences. JavaScript handles many characters
// incorrectly, either silently deleting them, or treating them as line endings.

            text = String(text);
            cx.lastIndex = 0;
            if (cx.test(text)) {
                text = text.replace(cx, function (a) {
                    return '\\u' +
                        ('0000' + a.charCodeAt(0).toString(16)).slice(-4);
                });
            }

// In the second stage, we run the text against regular expressions that look
// for non-JSON patterns. We are especially concerned with '()' and 'new'
// because they can cause invocation, and '=' because it can cause mutation.
// But just to be safe, we want to reject all unexpected forms.

// We split the second stage into 4 regexp operations in order to work around
// crippling inefficiencies in IE's and Safari's regexp engines. First we
// replace the JSON backslash pairs with '@' (a non-JSON character). Second, we
// replace all simple value tokens with ']' characters. Third, we delete all
// open brackets that follow a colon or comma or that begin the text. Finally,
// we look to see that the remaining characters are only whitespace or ']' or
// ',' or ':' or '{' or '}'. If that is so, then the text is safe for eval.

            if (/^[\],:{}\s]*$/
                    .test(text.replace(/\\(?:["\\\/bfnrt]|u[0-9a-fA-F]{4})/g, '@')
                        .replace(/"[^"\\\n\r]*"|true|false|null|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?/g, ']')
                        .replace(/(?:^|:|,)(?:\s*\[)+/g, ''))) {

// In the third stage we use the eval function to compile the text into a
// JavaScript structure. The '{' operator is subject to a syntactic ambiguity
// in JavaScript: it can begin a block or an object literal. We wrap the text
// in parens to eliminate the ambiguity.

                j = eval('(' + text + ')');

// In the optional fourth stage, we recursively walk the new structure, passing
// each name/value pair to a reviver function for possible transformation.

                return typeof reviver === 'function'
                    ? walk({'': j}, '')
                    : j;
            }

// If the text is not JSON parseable, then a SyntaxError is thrown.

            throw new SyntaxError('JSON.parse');
        };
    }
}());
// All code (c) 2012 mamoworld.com all rights reserved


/* eslint no-unused-vars: ["error", { "varsIgnorePattern": "^(CsvString2IntArray|CsvString2FloatArray)$" }] */


// see  http://www.svendtofte.com/code/usefull_prototypes/

Array.prototype.intArrayToString = function() {
	var a = new String();
	for (var i = 0; i < this.length; i++) {
		if(typeof this[i] != "number") {
			throw new Error("Array must be all numbers");
		} else if (this[i] < 0) {
			throw new Error("Numbers must be 0 and up");
		}
		a += String.fromCharCode(this[i]);
	}
	return a;
};

Array.prototype.compareArrays = function(arr) {
	if (this.length != arr.length) return false;
	for (var i = 0; i < arr.length; i++) {
		if (this[i].compareArrays) { //likely nested array
			if (!this[i].compareArrays(arr[i])) return false;
			else continue;
		}
		if (this[i] != arr[i]) return false;
	}
	return true;
};

Array.prototype.appendArray = function(otherArray, options) {
	var i;
	options = options || {};
	if(options.atFront){
		for (i = otherArray.length-1; i >=0; i--) {
			this.unshift(otherArray[i]);
		}
	}
	else {
		for (i = 0; i < otherArray.length; i++) {
			this.push(otherArray[i]);
		}
	}
};

// inserts all elements of otherArray into this array at pos.
// optionally before inserting the new elements, a given number of
// old entries starting at pos can be removed
Array.prototype.insertArray = function(pos, otherArray, options){
	// see https://stackoverflow.com/questions/7032550/javascript-insert-an-array-inside-another-array
	var numElementsToDelete = options.numElementsToDelete || 0;
	this.splice.apply(this, [pos, numElementsToDelete].concat(otherArray));
};

// A=[] is not good enough if you have referenced to your array (as these won't point to the new one)
// hence, this clear the existing array properly
// surprisingly, this is also the fastest method, see here: http://stackoverflow.com/questions/1232040/empty-an-array-in-javascript
Array.prototype.clear = function() {
	while(this.length > 0){
		this.pop();
	}
};

Array.prototype.map = function(fnc) {
	var a = new Array(this.length);
	for (var i = 0; i < this.length; i++) {
		a[i] = fnc(this[i]);
	}
	return a;
};


Array.prototype.mapWithIndex = function(fnc) {
	var a = new Array(this.length);
	for (var i = 0; i < this.length; i++) {
		a[i] = fnc(this[i],i);
	}
	return a;
};

Array.prototype.foreach = function (fnc) {
	for (var i = 0; i < this.length; i++) {
		fnc(this[i],i); // i is optional second argument in case you need the index
	}
};

Array.prototype.foreachSuccessivePair = function (fnc) {
	for (var i = 1; i < this.length; i++) {
		fnc(this[i-1],this[i]);
	}
};

Array.prototype.foldr = function(fnc,start) {
	var a = start;
	for (var i = this.length-1; i > -1; i--) {
		a = fnc(this[i],a);
	}
	return a;
};

Array.prototype.foldl = function(fnc,start) {
	var a = start;
	for (var i = 0; i < this.length; i++) {
		a = fnc(this[i],a);
	}
	return a;
};

Array.prototype.exists = function (x) {
	for (var i = 0; i < this.length; i++) {
		if (this[i] == x) return true;
	}
	return false;
};
Array.prototype.contains = Array.prototype.exists;


Array.prototype.all = function (f) {
	for (var i = 0; i < this.length; i++) {
		if (!f(this[i])) return false;
	}
	return true;
};


Array.prototype.filter = function(fnc) {
	var a = new Array();
	for (var i = 0; i < this.length; i++) {
		if (fnc(this[i])) {
			a.push(this[i]);
		}
	}
	return a;
};


Array.prototype.max = function() {
	if(this.length==0){
		return NaN;
	}
	return this.foldl(Math.max,this[0]);
};

Array.prototype.min = function() {
	if(this.length==0){
		return NaN;
	}
	return this.foldl(Math.min,this[0]);
};

Array.prototype.average = function() {
	if(this.length==0){
		return NaN;
	}
	var len = this.length;
	return this.foldl(function(entry,result){
		return (result + (entry/len));
	},0);
};

Array.prototype.getEntryClosestTo = function (myVal){
	if(this.length == 0){
		return null;
	}

	var bestIndex = 0;
	var bestDistance = Math.abs(this[0]-myVal);

	for(var i=1; i< this.length; i++){
		var thisDistance = Math.abs(this[i]-myVal);
		if(thisDistance < bestDistance){
			bestDistance =thisDistance;
			bestIndex = i;
		}
	}
	return bestIndex;
};

Array.prototype.random = function() {
	return this[Math.floor((Math.random()*this.length))];
};

Array.prototype.shuffle = function(){
	var j, x, i;
	for (i = this.length; i; i--) {
		j = Math.floor(Math.random() * i);
		x = this[i - 1];
		this[i - 1] = this[j];
		this[j] = x;
	}
};

Array.prototype.prettyPrint = function(){
	var result ="[" +
	this.map(function(entry){return '"'+entry+'"';}).join(",")
	+"]";
	return result;
};


function CsvString2StringArray(csvString) {
	return csvString.split(",");
}

function CsvString2IntArray(csvString) {
	return CsvString2StringArray(csvString).map(function (x) { return parseInt(x, 10); });
}

function CsvString2FloatArray(csvString) {
	return CsvString2StringArray(csvString).map(function (x) { return parseFloat(x, 10); });
}

// similar to the Path module of nodejs + extra functionality to sanitize filenames

/* eslint no-unused-vars: ["error", { "varsIgnorePattern": "^(Path)$" }] */
/* global $*/


var Path = (function() {
	var sep = ($.os.indexOf("Windows") != -1) ? "\\" : "/";

	var splitFilenameInPrefixAndSuffix = (function() {
		var splitSuffixRegEx = /^(.*)(\.[^.]*)$/;

		function split(filename) {
			var parse = splitSuffixRegEx.exec(filename);
			var result = {};
			if (parse) {
				result.prefix = parse[1];
				result.suffix = parse[2];
			} else {
				result.prefix = filename;
				result.suffix = "";
			}
			return result;
		}
		return split;
	})();

	var splitPathInDirnameAndBasename = (function() {
		var splitPathRegEx = /^(?:(.*)[\\\/])?([^\\\/]*)$/;

		function split(filename) {
			var parse = splitPathRegEx.exec(filename);
			var result = {};
			if (parse) {
				result.dirname = parse[1];
				result.basename = parse[2];
			} else {
				throw "splitPathRegexp should always match !?!?";
			}
			return result;
		}
		return split;
	})();

	var removeSeparatorAtEnd = (function() {
		var myRegEx = /[\\\/]+$/;

		function remove(path) {
			return path.replace(myRegEx, "");
		}
		return remove;
	})();



	function basename(path) {
		return splitPathInDirnameAndBasename(path).basename;
	}

	function dirname(path) {
		return splitPathInDirnameAndBasename(path).dirname;
	}

	function basenameWithoutExt(path) {
		return splitFilenameInPrefixAndSuffix(basename(path)).prefix;
	}

	function extname(path) {
		return splitFilenameInPrefixAndSuffix(basename(path)).suffix;
	}

	function extnameNoDot(path) {
		var ext = extname(path);
		var result = (ext.length > 0)? ext.substring(1):ext;
		return result;
	}

	function joinTwo(path1,path2){
		return (removeSeparatorAtEnd(path1) + sep + path2);
	}

	function join() {
		if(arguments.length == 0) return "";
		var result = arguments[0];
		for(var i=1; i < arguments.length; i++){
			result = joinTwo(result,arguments[i]);
		}
		return result;
	}


	//////////////////////////
	// Sanitize a string to be safe for use as a filename by removing directory paths and invalid characters.
	//
	// sanitize-filename removes the following:
	//
	//     Control characters (0x00-0x1f and 0x80-0x9f)
	//     Reserved characters (/ ? < > \ : * | ")
	//     Unix reserved filenames (. and ..)
	//     Windows reserved filenames (CON PRN AUX NUL COM1 COM2 COM3 COM4 COM5 COM6 COM7 COM8 COM9 LPT1 LPT2 LPT3 LPT4 LPT5 LPT6 LPT7 LPT8 and LPT9)
	//
	// The resulting string is truncated to 255 bytes in length. The string will not contain any directory paths and will be safe to use as a filename.
	//




	// Examples:
	// sanitizeFilename("my?File/7") --> "myFile7"
	// sanitizeFilename("my?File/7",{replacement:'_'}) --> "my_File_7"
	// sanitizeFilename("myLongFile.jpg",{maxLength:8}) --> "myLo.jpg"

	var sanitizeFilename = (function() {


		////////// fix for truncate which relies on Buffer.byteLength which does not exist in ExtendScript
		function lengthInUtf8Bytes(str) {
			// Matches only the 10.. bytes that are non-initial characters in a multi-byte sequence.
			var m = encodeURIComponent(str).match(/%[89ABab]/g);
			return str.length + (m ? m.length : 0);
		}

		////////// truncate
		// based on https://www.npmjs.com/package/truncate-utf8-bytes

		function isHighSurrogate(codePoint) {
			return codePoint >= 0xd800 && codePoint <= 0xdbff;
		}

		function isLowSurrogate(codePoint) {
			return codePoint >= 0xdc00 && codePoint <= 0xdfff;
		}

		function truncate(string, byteLength) {
			if (typeof string !== "string") {
				throw new Error("Input must be string");
			}

			var charLength = string.length;
			var curByteLength = 0;
			var codePoint;
			var segment;

			for (var i = 0; i < charLength; i += 1) {
				codePoint = string.charCodeAt(i);
				segment = string[i];

				if (isHighSurrogate(codePoint) && isLowSurrogate(string.charCodeAt(i + 1))) {
					i += 1;
					segment += string[i];
				}

				curByteLength += lengthInUtf8Bytes(segment);

				if (curByteLength === byteLength) {
					return string.slice(0, i + 1);
				} else if (curByteLength > byteLength) {
					return string.slice(0, i - segment.length + 1);
				}
			}

			return string;
		}



		///////// sanitize
		// based on  https://www.npmjs.com/package/sanitize-filename

		var illegalRe = /[\/\?<>\\:\*\|":]/g;
		/*eslint no-control-regex: "off"*/
		var controlRe = /[\x00-\x1f\x80-\x9f]/g;
		var reservedRe = /^\.+$/;
		var windowsReservedRe = /^(con|prn|aux|nul|com[0-9]|lpt[0-9])(\..*)?$/i;
		var linebreaksRe = /\r?\n|\r/g;

		function sanitize(input, options) {
			var sanitized = input;

			if(options.removeLinebreaks == true){
				sanitized = sanitized.replace(linebreaksRe,'');  // get rid of the linebreak completely instead of replacing it by the replacement char which will happen otherwise
			}
			sanitized = sanitized
			.replace(illegalRe, options.replacement)
			.replace(controlRe, options.replacement)
			.replace(reservedRe, options.replacement)
			.replace(windowsReservedRe, options.replacement);


			// we truncate to 255 characters, but leave the suffix untouched if possible
			var split = splitFilenameInPrefixAndSuffix(sanitized);
			var suffixLength = split.suffix.length;
			var truncated = (suffixLength < 10) ? // for >= 10 it is not really a typical suffix, so we shouldn't treat it as one...
			(truncate(split.prefix, options.maxLength - suffixLength) + split.suffix) :
			(truncate(sanitized, options.maxLength));
			return truncated;
		}

		function sanitizeWithOptions(input, options) {
			options = options || {};
			options.replacement = options.replacement || '';
			options.maxLength = options.maxLength || 255;

			var output = sanitize(input, options);
			if (options.replacement === '') {
				return output;
			}
			return sanitize(output, options);
		}

		return sanitizeWithOptions;
	})();

	function sanitizePath(path, options) {
		var dir = dirname(path);
		var file = basename(path);
		var fileSanitized = sanitizeFilename(file, options);
		return join(dir, fileSanitized);
	}
	//////////// END sanitize

	return {
		dirname: dirname,
		basename: basename,
		basenameWithoutExt: basenameWithoutExt,
		extname: extname,
		extnameNoDot: extnameNoDot,
		sep: sep,
		join: join,
		sanitizeFilename: sanitizeFilename,
		sanitizePath: sanitizePath,
	};
})();

  function doInFramesFormat(qeSequence, doSomething) {
    var framesFormat = 109;
    var oldFormat = qeSequence.videoDisplayFormat;
    qeSequence.setVideoDisplayFormat(framesFormat);
    try {
      doSomething();
    } catch (e) {
      throw e;
    } finally {
      qeSequence.setVideoDisplayFormat(oldFormat);
    }
  };

  function forAllMarkers(sequence, doSomething) {
    var markers = sequence.markers;
    if (markers == null) return;
    var i = 0;
    for (var m = markers.getFirstMarker(); m != null; m = markers.getNextMarker(m)) {
      doSomething(m, i);
      i++;
    }
  };

  function namePatternToInstance(pattern, m, i) {
    var result = pattern;
    result = result.replace(/#NUM(\d)/g, function(match, number) {
      number = parseInt(number);
      var result = "" + i;
      while (result.length < number) result = "0" + result;
      return result;
    });
    result = result.replace(/#NUM/g, i);
    result = result.replace(/#COMMENT/g, m.comments);
    result = result.replace(/#NAME/g, m.name);
    result = result.replace(/#PROJECT/g, getProjectName());
    result = result.replace(/#SEQUENCE/g, getActiveSequenceName());
    return result;
  };

  function makeFreshFilename(path, existingFilenames) {
    var filename = Path.basename(path);
    var dir = Path.dirname(path)
    filename = Path.sanitizeFilename(filename, {
      replacement: '_',
      maxLength: 240, // keep some room to the max allowed 255, since we need some space for the numbers we might attach,
      removeLinebreaks: true
    });
    var prefix = Path.basenameWithoutExt(filename);
    var suffix = Path.extname(filename);
    var i = 2;

    var newPath = Path.join(dir, prefix + suffix);
    while (existingFilenames.exists(newPath)) {
      var newPath = Path.join(dir, prefix + i + suffix);
      i++;
    }

    return newPath;
  };



  function getFilenamesFromPattern(namePattern){
    return JSON.stringify(getFilenamesFromPatternAndExportOne(namePattern,-1));
  };


  function getFilenamesFromPatternAndExportOne(namePattern, markerIndexToExport) {
    var processedFilenames = [];
    app.enableQE();
    var qeSequence = qe.project.getActiveSequence();

    var suffix = namePattern.slice(namePattern.length - 3);
    var format = suffix.toLowerCase();
    if (qeSequence != undefined) {
      doInFramesFormat(qeSequence, function() {
        forAllMarkers(app.project.activeSequence, function(m, i) {
          var filename = namePatternToInstance(namePattern, m, i);
          filename = makeFreshFilename(filename, processedFilenames);
          var timeInFrames = Math.floor(m.start.seconds * qeSequence.videoFrameRate);
          var timecode = "" + timeInFrames;

          if (markerIndexToExport == i) {
            if (format == "png") {
              qeSequence.exportFramePNG(timecode, filename);
            } else if (format == "jpg") {
              qeSequence.exportFrameJPEG(timecode, filename);
            } else if (format == "dpx") {
              qeSequence.exportFrameDPX(timecode, filename);
            } else if (format == "tif") {
              qeSequence.exportFrameTIFF(timecode, filename);
            }

          }
          processedFilenames.push(filename);
        });
      });
    }
    return processedFilenames;
  };

  function exportMarkerFrame(namePattern, num) {
    result = {};
    var filenames = getFilenamesFromPatternAndExportOne(namePattern, num);
    if(filenames.length <= num){
      result.markerDoesNotExist = true;
    }
    else {
      result.filename = filenames[num];
      result.markerDoesNotExist = false;
    }
    return JSON.stringify(result);
  };

  function importFile(footagePath, options) {
    if (options.imageSequence) {
      var suppressUI = 1;
      var importAsNumberedStills = 1;
      //  unfortunately, we are forced to import in this bin since we
      //  HAVE to specify a bin and cannot figure out which one is currently selected
      //  at least we select it to make sure the user notices where the imports go
      var targetBin = app.project.rootItem;
      app.project.rootItem.select();
      app.project.importFiles([footagePath], suppressUI, targetBin, importAsNumberedStills);
    } else {
      app.project.importFiles([footagePath]);
    }
  };


  function getActiveSequenceName() {
    if (app.project.activeSequence == undefined) {
      return "";
    }
    return app.project.activeSequence.name;
  };

  function getProjectName() {
    var name = app.project.name;
    name = name.replace(/\.prproj$/i, "");
    return name;
  };

  function getProjectFolder() {
    var projFile = app.project.path;

    // get rid of the \\?\ prefix on Windows
    var projFile = projFile.replace(/^\\\\\?\\/, "");



    var pathPattern = /^.*[\\\/]/;
    var match = pathPattern.exec(projFile);

    var projectPath = match ? match : "none";
    return projectPath;
  };

  return {
    getFilenamesFromPattern: getFilenamesFromPattern,
    exportMarkerFrame: exportMarkerFrame,
    importFile: importFile,
    getProjectFolder: getProjectFolder,
    getActiveSequenceName: getActiveSequenceName
  };
})());
